-- delete the configuration of the old module
SET @tmp=0;
SELECT (@tmp:=configuration_group_id) as tmp FROM configuration_group WHERE configuration_group_title= 'Magic Zoom';
DELETE FROM configuration WHERE configuration_group_id = @tmp AND configuration_group_id != 0 and configuration_group_id IS NOT NULL;
DELETE FROM configuration_group WHERE configuration_group_id = @tmp AND configuration_group_id != 0 and configuration_group_id IS NOT NULL;

-- create config table
DROP TABLE IF EXISTS magiczoom_configuration;
CREATE TABLE magiczoom_configuration (
    `id` int unsigned NOT NULL auto_increment,
    `block` varchar(64) NOT NULL,
    `name` varchar(64) NOT NULL,
    `value` text,
    `default_value` text,
    `enabled` tinyint(1) unsigned NOT NULL,
    `default_enabled` tinyint(1) unsigned NOT NULL,
    PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- defaut config
INSERT INTO magiczoom_configuration (`block`, `name`, `value`, `default_value`, `enabled`,`default_enabled`) VALUES 
 ('default', 'thumb-max-width', '200', '200', 1, 1),
 ('default', 'thumb-max-height', '200', '200', 1, 1),
 ('default', 'zoomWidth', 'auto', 'auto', 1, 1),
 ('default', 'zoomHeight', 'auto', 'auto', 1, 1),
 ('default', 'zoomPosition', 'right', 'right', 1, 1),
 ('default', 'zoomDistance', '15', '15', 1, 1),
 ('default', 'extra-thumb-max-width', '50', '50', 1, 1),
 ('default', 'extra-thumb-max-height', '50', '50', 1, 1),
 ('default', 'thumb-margin', '1', '1', 1, 1),
 ('default', 'thumb-margin-top', '5', '5', 1, 1),
 ('default', 'square-images', 'disable', 'disable', 1, 1),
 ('default', 'lazyZoom', 'No', 'No', 1, 1),
 ('default', 'rightClick', 'No', 'No', 1, 1),
 ('default', 'cssClass', '', '', 1, 1),
 ('default', 'link-to-product-page', 'Yes', 'Yes', 1, 1),
 ('default', 'show-message', 'No', 'No', 1, 1),
 ('default', 'message', 'Move your mouse over image', 'Move your mouse over image', 1, 1),
 ('default', 'imagemagick', 'off', 'off', 1, 1),
 ('default', 'image-quality', '75', '75', 1, 1),
 ('default', 'zoomMode', 'zoom', 'zoom', 1, 1),
 ('default', 'zoomOn', 'hover', 'hover', 1, 1),
 ('default', 'upscale', 'Yes', 'Yes', 1, 1),
 ('default', 'smoothing', 'Yes', 'Yes', 1, 1),
 ('default', 'variableZoom', 'No', 'No', 1, 1),
 ('default', 'zoomCaption', 'off', 'off', 1, 1),
 ('default', 'watermark', '', '', 1, 1),
 ('default', 'watermark-max-width', '30%', '30%', 1, 1),
 ('default', 'watermark-max-height', '30%', '30%', 1, 1),
 ('default', 'watermark-opacity', '50', '50', 1, 1),
 ('default', 'watermark-position', 'center', 'center', 1, 1),
 ('default', 'watermark-offset-x', '0', '0', 1, 1),
 ('default', 'watermark-offset-y', '0', '0', 1, 1),
 ('default', 'hint', 'once', 'once', 1, 1),
 ('default', 'textHoverZoomHint', 'Hover to zoom', 'Hover to zoom', 1, 1),
 ('default', 'textClickZoomHint', 'Click to zoom', 'Click to zoom', 1, 1),
 ('default', 'zoomModeForMobile', 'off', 'off', 1, 1),
 ('default', 'textHoverZoomHintForMobile', 'Touch to zoom', 'Touch to zoom', 1, 1),
 ('default', 'textClickZoomHintForMobile', 'Double tap or pinch to zoom', 'Double tap or pinch to zoom', 1, 1),
 ('product', 'enable-effect', 'Yes', 'Yes', 1, 1),
 ('product', 'thumb-max-width', '200', '200', 1, 1),
 ('product', 'thumb-max-height', '0', '0', 1, 1),
 ('product', 'zoomWidth', 'auto', 'auto', 0, 0),
 ('product', 'zoomHeight', 'auto', 'auto', 0, 0),
 ('product', 'paps-image-max-width', '200', '200', 0, 0),
 ('product', 'paps-image-max-height', '200', '200', 0, 0),
 ('product', 'zoomPosition', 'right', 'right', 0, 0),
 ('product', 'paps-thumb-max-width', '100', '100', 0, 0),
 ('product', 'paps-thumb-max-height', '100', '100', 0, 0),
 ('product', 'zoomDistance', '15', '15', 0, 0),
 ('product', 'extra-thumb-max-width', '50', '50', 0, 0),
 ('product', 'extra-thumb-max-height', '50', '50', 0, 0),
 ('product', 'thumb-margin', '1', '1', 0, 0),
 ('product', 'thumb-margin-top', '5', '5', 0, 0),
 ('product', 'selectorTrigger', 'click', 'click', 0, 0),
 ('product', 'transitionEffect', 'Yes', 'Yes', 0, 0),
 ('product', 'lazyZoom', 'No', 'No', 0, 0),
 ('product', 'rightClick', 'No', 'No', 0, 0),
 ('product', 'cssClass', '', '', 0, 0),
 ('product', 'show-message', 'No', 'No', 0, 0),
 ('product', 'message', 'Move your mouse over image', 'Move your mouse over image', 0, 0),
 ('product', 'zoomMode', 'zoom', 'zoom', 0, 0),
 ('product', 'zoomOn', 'hover', 'hover', 0, 0),
 ('product', 'upscale', 'Yes', 'Yes', 0, 0),
 ('product', 'smoothing', 'Yes', 'Yes', 0, 0),
 ('product', 'variableZoom', 'No', 'No', 0, 0),
 ('product', 'zoomCaption', 'off', 'off', 0, 0),
 ('product', 'hint', 'once', 'once', 0, 0),
 ('product', 'textHoverZoomHint', 'Hover to zoom', 'Hover to zoom', 0, 0),
 ('product', 'textClickZoomHint', 'Click to zoom', 'Click to zoom', 0, 0),
 ('product', 'zoomModeForMobile', 'off', 'off', 0, 0),
 ('product', 'textHoverZoomHintForMobile', 'Touch to zoom', 'Touch to zoom', 0, 0),
 ('product', 'textClickZoomHintForMobile', 'Double tap or pinch to zoom', 'Double tap or pinch to zoom', 0, 0),
 ('category', 'enable-effect', 'No', 'No', 0, 0),
 ('category', 'thumb-max-width', '100', '100', 1, 1),
 ('category', 'thumb-max-height', '100', '100', 1, 1),
 ('category', 'zoomWidth', 'auto', 'auto', 0, 0),
 ('category', 'zoomHeight', 'auto', 'auto', 0, 0),
 ('category', 'zoomPosition', 'right', 'right', 0, 0),
 ('category', 'zoomDistance', '15', '15', 0, 0),
 ('category', 'extra-thumb-max-width', '50', '50', 0, 0),
 ('category', 'extra-thumb-max-height', '50', '50', 0, 0),
 ('category', 'thumb-margin', '1', '1', 0, 0),
 ('category', 'thumb-margin-top', '5', '5', 0, 0),
 ('category', 'lazyZoom', 'No', 'No', 0, 0),
 ('category', 'rightClick', 'No', 'No', 0, 0),
 ('category', 'cssClass', '', '', 0, 0),
 ('category', 'link-to-product-page', 'Yes', 'Yes', 0, 0),
 ('category', 'show-message', 'No', 'No', 1, 1),
 ('category', 'message', 'Move your mouse over image', 'Move your mouse over image', 0, 0),
 ('category', 'zoomMode', 'zoom', 'zoom', 0, 0),
 ('category', 'zoomOn', 'hover', 'hover', 0, 0),
 ('category', 'upscale', 'Yes', 'Yes', 0, 0),
 ('category', 'smoothing', 'Yes', 'Yes', 0, 0),
 ('category', 'variableZoom', 'No', 'No', 0, 0),
 ('category', 'zoomCaption', 'off', 'off', 0, 0),
 ('category', 'hint', 'once', 'once', 0, 0),
 ('category', 'textHoverZoomHint', 'Hover to zoom', 'Hover to zoom', 0, 0),
 ('category', 'textClickZoomHint', 'Click to zoom', 'Click to zoom', 0, 0),
 ('category', 'zoomModeForMobile', 'off', 'off', 0, 0),
 ('category', 'textHoverZoomHintForMobile', 'Touch to zoom', 'Touch to zoom', 0, 0),
 ('category', 'textClickZoomHintForMobile', 'Double tap or pinch to zoom', 'Double tap or pinch to zoom', 0, 0),
 ('products_new', 'enable-effect', 'No', 'No', 0, 0),
 ('products_new', 'thumb-max-width', '100', '100', 1, 1),
 ('products_new', 'thumb-max-height', '100', '100', 1, 1),
 ('products_new', 'zoomWidth', 'auto', 'auto', 0, 0),
 ('products_new', 'zoomHeight', 'auto', 'auto', 0, 0),
 ('products_new', 'zoomPosition', 'right', 'right', 0, 0),
 ('products_new', 'zoomDistance', '15', '15', 0, 0),
 ('products_new', 'extra-thumb-max-width', '50', '50', 0, 0),
 ('products_new', 'extra-thumb-max-height', '50', '50', 0, 0),
 ('products_new', 'thumb-margin', '1', '1', 0, 0),
 ('products_new', 'thumb-margin-top', '5', '5', 0, 0),
 ('products_new', 'lazyZoom', 'No', 'No', 0, 0),
 ('products_new', 'rightClick', 'No', 'No', 0, 0),
 ('products_new', 'cssClass', '', '', 0, 0),
 ('products_new', 'link-to-product-page', 'Yes', 'Yes', 0, 0),
 ('products_new', 'show-message', 'No', 'No', 1, 1),
 ('products_new', 'message', 'Move your mouse over image', 'Move your mouse over image', 0, 0),
 ('products_new', 'zoomMode', 'zoom', 'zoom', 0, 0),
 ('products_new', 'zoomOn', 'hover', 'hover', 0, 0),
 ('products_new', 'upscale', 'Yes', 'Yes', 0, 0),
 ('products_new', 'smoothing', 'Yes', 'Yes', 0, 0),
 ('products_new', 'variableZoom', 'No', 'No', 0, 0),
 ('products_new', 'zoomCaption', 'off', 'off', 0, 0),
 ('products_new', 'hint', 'once', 'once', 0, 0),
 ('products_new', 'textHoverZoomHint', 'Hover to zoom', 'Hover to zoom', 0, 0),
 ('products_new', 'textClickZoomHint', 'Click to zoom', 'Click to zoom', 0, 0),
 ('products_new', 'zoomModeForMobile', 'off', 'off', 0, 0),
 ('products_new', 'textHoverZoomHintForMobile', 'Touch to zoom', 'Touch to zoom', 0, 0),
 ('products_new', 'textClickZoomHintForMobile', 'Double tap or pinch to zoom', 'Double tap or pinch to zoom', 0, 0),
 ('special_products', 'enable-effect', 'No', 'No', 0, 0),
 ('special_products', 'thumb-max-width', '100', '100', 1, 1),
 ('special_products', 'thumb-max-height', '100', '100', 1, 1),
 ('special_products', 'zoomWidth', 'auto', 'auto', 0, 0),
 ('special_products', 'zoomHeight', 'auto', 'auto', 0, 0),
 ('special_products', 'zoomPosition', 'right', 'right', 0, 0),
 ('special_products', 'zoomDistance', '15', '15', 0, 0),
 ('special_products', 'extra-thumb-max-width', '50', '50', 0, 0),
 ('special_products', 'extra-thumb-max-height', '50', '50', 0, 0),
 ('special_products', 'thumb-margin', '1', '1', 0, 0),
 ('special_products', 'thumb-margin-top', '5', '5', 0, 0),
 ('special_products', 'lazyZoom', 'No', 'No', 0, 0),
 ('special_products', 'rightClick', 'No', 'No', 0, 0),
 ('special_products', 'cssClass', '', '', 0, 0),
 ('special_products', 'link-to-product-page', 'Yes', 'Yes', 0, 0),
 ('special_products', 'show-message', 'No', 'No', 1, 1),
 ('special_products', 'message', 'Move your mouse over image', 'Move your mouse over image', 0, 0),
 ('special_products', 'zoomMode', 'zoom', 'zoom', 0, 0),
 ('special_products', 'zoomOn', 'hover', 'hover', 0, 0),
 ('special_products', 'upscale', 'Yes', 'Yes', 0, 0),
 ('special_products', 'smoothing', 'Yes', 'Yes', 0, 0),
 ('special_products', 'variableZoom', 'No', 'No', 0, 0),
 ('special_products', 'zoomCaption', 'off', 'off', 0, 0),
 ('special_products', 'hint', 'once', 'once', 0, 0),
 ('special_products', 'textHoverZoomHint', 'Hover to zoom', 'Hover to zoom', 0, 0),
 ('special_products', 'textClickZoomHint', 'Click to zoom', 'Click to zoom', 0, 0),
 ('special_products', 'zoomModeForMobile', 'off', 'off', 0, 0),
 ('special_products', 'textHoverZoomHintForMobile', 'Touch to zoom', 'Touch to zoom', 0, 0),
 ('special_products', 'textClickZoomHintForMobile', 'Double tap or pinch to zoom', 'Double tap or pinch to zoom', 0, 0),
 ('featured_products', 'enable-effect', 'No', 'No', 0, 0),
 ('featured_products', 'thumb-max-width', '200', '200', 0, 0),
 ('featured_products', 'thumb-max-height', '200', '200', 0, 0),
 ('featured_products', 'zoomWidth', 'auto', 'auto', 0, 0),
 ('featured_products', 'zoomHeight', 'auto', 'auto', 0, 0),
 ('featured_products', 'zoomPosition', 'right', 'right', 0, 0),
 ('featured_products', 'zoomDistance', '15', '15', 0, 0),
 ('featured_products', 'extra-thumb-max-width', '50', '50', 0, 0),
 ('featured_products', 'extra-thumb-max-height', '50', '50', 0, 0),
 ('featured_products', 'thumb-margin', '1', '1', 0, 0),
 ('featured_products', 'thumb-margin-top', '5', '5', 0, 0),
 ('featured_products', 'lazyZoom', 'No', 'No', 0, 0),
 ('featured_products', 'rightClick', 'No', 'No', 0, 0),
 ('featured_products', 'cssClass', '', '', 0, 0),
 ('featured_products', 'link-to-product-page', 'Yes', 'Yes', 0, 0),
 ('featured_products', 'show-message', 'No', 'No', 0, 0),
 ('featured_products', 'message', 'Move your mouse over image', 'Move your mouse over image', 0, 0),
 ('featured_products', 'zoomMode', 'zoom', 'zoom', 0, 0),
 ('featured_products', 'zoomOn', 'hover', 'hover', 0, 0),
 ('featured_products', 'upscale', 'Yes', 'Yes', 0, 0),
 ('featured_products', 'smoothing', 'Yes', 'Yes', 0, 0),
 ('featured_products', 'variableZoom', 'No', 'No', 0, 0),
 ('featured_products', 'zoomCaption', 'off', 'off', 0, 0),
 ('featured_products', 'hint', 'once', 'once', 0, 0),
 ('featured_products', 'textHoverZoomHint', 'Hover to zoom', 'Hover to zoom', 0, 0),
 ('featured_products', 'textClickZoomHint', 'Click to zoom', 'Click to zoom', 0, 0),
 ('featured_products', 'zoomModeForMobile', 'off', 'off', 0, 0),
 ('featured_products', 'textHoverZoomHintForMobile', 'Touch to zoom', 'Touch to zoom', 0, 0),
 ('featured_products', 'textClickZoomHintForMobile', 'Double tap or pinch to zoom', 'Double tap or pinch to zoom', 0, 0),
 ('default', 'version', '4.9.1', '4.9.1', 1, 1);

